#include <TCanvas.h>
#include <TCutG.h>
#include <TFile.h>
#include <TGraph.h>
#include <TH2.h>
#include <TSpectrum.h>
#include <vector>
#include <TStyle.h>

using namespace std;

void PeakFinder(vector<TSpectrum*> *sPeak , vector<int> *vPeak, TH2F *h , vector<vector<Double_t>> *LinePos, Double_t sigma, Double_t threshold);
vector<TCutG*> PeakLinker(vector<vector<Double_t>> *LinePos);

struct PeakData{
    Double_t X ;
    Double_t Y ;
    int LineId ;
    int index  ;

} ;

struct Indexed1D{
    Double_t x ;
    int index  ;
} ;

struct Indexed2D{
    Double_t x ;
    int id  ;
    int index  ;
} ;

vector<Double_t> diff(const vector<Double_t>& input);

double distancePeak(const PeakData& p1, const PeakData& p2) ;
