#include "TChain.h"
#include "TFile.h"
#include "TH1.h"
#include<iostream>

using namespace std;

////////////////////////////////////////////////////////
TChain* chain;
int nentries;
TH1F* hQ[20];

double FF_Q;
int FPMW_Section;


/////////////////////////////////////////////////////////
void LoadRootFile(){
  chain = new TChain("PhysicsTree");
  chain->Add("../../root/analysis/CalibVamos241.root");
}

/////////////////////////////////////////////////////////
void FillCharge(){
  LoadRootFile();
  nentries = chain->GetEntries();
  cout << "Number of entries: " << nentries << endl;

  TFile* ofile = new TFile("histo/charge.root","recreate");

  for(int i=0; i<20; i++){
    TString histo_name = Form("hQ_sec%d",i);
    hQ[i] = new TH1F(histo_name,histo_name,1000,0,80);
  }

  chain->SetBranchStatus("FF_Q13","true");
  chain->SetBranchAddress("FF_Q13",&FF_Q);

  chain->SetBranchStatus("FPMW_Section","true");
  chain->SetBranchAddress("FPMW_Section",&FPMW_Section);

  for(int i=0; i<nentries; i++){
    chain->GetEntry(i);

    if(i%100000==0){
      cout << "\033[34m\r Processing tree..." << (double)i/nentries*100 << "\% done" << flush;
    }
    if (FPMW_Section != -1){
      //cout << "FPMW_Section" << FPMW_Section << endl;
      hQ[FPMW_Section]->Fill(FF_Q);
    }
  }
  ofile->Write();
  ofile->Close();
}
