#include "IC_Dampen_Recombination.h"
using namespace std;


void HistoFillerIC(bool cut = false);

void IC_Dampen_Recombination(bool Fill = false){


  if (Fill==true) HistoFillerIC(false);


  TFile *infile = TFile::Open("Output/HistoDampen.root"); 
  TFile *OutFile = new TFile("Output/FitIC.root","recreate");
  vector<TH2F*> hICX, hICY ;
  vector<TH1F*> hICX_Profile, hICY_Profile ;

  for (int seg = 0 ; seg < 11; seg++ ){

    hICX.push_back((TH2F*)infile->Get(Form("hChio_X_%d",seg)));
    hICY.push_back((TH2F*)infile->Get(Form("hChio_Y_%d",seg)));
    hICX_Profile.push_back((TH1F*)infile->Get(Form("hChio_X_%d_pfx",seg)));
    hICY_Profile.push_back((TH1F*)infile->Get(Form("hChio_Y_%d_pfx",seg)));

  }

  //===========================================================================================================
  //                                         Fit Histo
  //===========================================================================================================



  vector<TF1*> Fit_Y(11);
  double p0[11],p1[11],p2[11],p3[11], xmin[11];
  
  p0[0] = 2350  ; p1[0] = 0.00065  ; p3[0] = -54  ; xmin[0] = -60; 
  p0[1] = 2350  ; p1[1] = 0.00065  ; p3[1] = -54  ; xmin[0] = -58; 
  p0[2] = 2350  ; p1[2] = 0.00065  ; p3[2] = -54  ; xmin[0] = -60; 
  p0[3] = 2350  ; p1[3] = 0.00065  ; p3[3] = -54  ; xmin[0] = -60; 
  p0[4] = 2350  ; p1[4] = 0.00065  ; p3[4] = -54  ; xmin[0] = -60; 
  p0[5] = 2350  ; p1[5] = 0.00065  ; p3[5] = -54  ; xmin[0] = -60; 
  p0[6] = 2350  ; p1[6] = 0.00065  ; p3[6] = -54  ; xmin[0] = -60; 
  p0[7] = 2350  ; p1[7] = 0.00065  ; p3[7] = -54  ; xmin[0] = -60; 
  p0[8] = 2350  ; p1[8] = 0.00065  ; p3[8] = -54  ; xmin[0] = -60; 
  p0[9] = 2350  ; p1[9] = 0.00065  ; p3[9] = -54  ; xmin[0] = -60; 
  p0[10]= 2350  ; p1[10]= 0.00065  ; p3[10]= -54  ; xmin[0] = -60; 

  OutFile->cd();
  for (int seg=0; seg<11 ; seg++){

    Fit_Y[seg] = new
      TF1(Form("Fit_Y_Expo_IC%d",seg),[](double *x, double*p) {

          if (/*x[0]>-50 && x[0]<50 && x[0] > 60 && x[0] < -60*/ false) {
          TF1::RejectPoint();
          }
          //Define here the function
          return p[0] * exp(p[1]* (x[0])) ;
          },-60,60,2);


    Fit_Y[seg]->SetParameters(p0[seg],p1[seg],p3[seg]);


    cout << "****************" << endl << "IC"<<seg << endl;
    hICY_Profile[seg]->Fit(Fit_Y[seg] ,"R"); 
    Fit_Y[seg]->Write();

  }//end loop on histo



  //===========================================================================================================
  //                                        Draw histo
  //===========================================================================================================

  vector<TCanvas*> cIC(11);
  for (int seg=0; seg<2; seg++){
    cIC[seg] = new TCanvas
      (Form("cIC%d",seg),Form("cIC%d",seg),100,100,1000,600);
    cIC[seg]->Divide(2);

    cIC[seg]->cd(1);
    hICY[seg]->Draw();

    cIC[seg]->cd(2);
    hICY_Profile[seg]->Draw();
    Fit_Y[seg]->Draw("same");


  }

  OutFile->Close();
}


void HistoFillerIC(bool cut){
  //===========================================================================================================
  //                                              INPUT
  //===========================================================================================================

  TChain* chain = new TChain("PhysicsTree");
  chain->Add("../../../root/analysis/VamosCalib241.root");

  double FF_IC_X, FF_IC_Y;
  TICPhysics* IC = new TICPhysics();

  chain->SetBranchStatus("FF_IC_X", true);
  chain->SetBranchAddress("FF_IC_X", &FF_IC_X);
  chain->SetBranchStatus("FF_IC_Y", true);
  chain->SetBranchAddress("FF_IC_Y", &FF_IC_Y);
  chain->SetBranchStatus("IC", true);
  chain->SetBranchAddress("IC", &IC);


  TFile *fcut = new TFile("Output/CutZ.root","open") ;
  TCutG *CutZ ;
  CutZ = (TCutG*)fcut->Get("CutTry") ;

  //===========================================================================================================
  //                                        Declare and fill  histo
  //===========================================================================================================

  vector<TH2F*> hICX, hICY ;
  vector<TH1F*> hICX_Profile, hICY_Profile ;

  int NSegmentChio = 11 ;

  for (int seg = 0 ; seg < 11 ; seg++){

    TH2F* hChio_X = new TH2F(Form("hChio_X_%d",seg) ,Form("hChio_X_%d",seg) ,500 ,-800 ,800 ,500 ,2000,9500 );
    TH2F* hChio_Y = new TH2F(Form("hChio_Y_%d",seg) ,Form("hChio_Y_%d",seg) ,500 ,-160 ,160 ,500 ,2000,9500 );

    TH1F* hProfile_X = (TH1F*)hChio_X->ProfileX();
    TH1F* hProfile_Y = (TH1F*)hChio_Y->ProfileX();

    hICX.push_back(hChio_X);
    hICY.push_back(hChio_Y);
    hICX_Profile.push_back(hProfile_X);
    hICY_Profile.push_back(hProfile_Y);

  } //end loop on segment


  // Loop on event
  int Nentries = chain->GetEntries();

  for (int e = 0 ; e<Nentries ; e++){ // to be parallelised

    if ((e/Nentries)*100 %100 ==0){ 
      cout <<  "Please wait, we are  " << e * 100. / Nentries << "% done ..\r" << flush;
    } 

    chain->GetEntry(e);


    //if we want to do cut on DE_E we need to define those parameters
    double DE = 0 ,E = 0, Etot = 0 ;

    for (int seg = 0 ;  seg < sizeof(IC->fIC_raw)/sizeof(IC->fIC_raw[0]) ; seg++ ){
      if (seg >4) E+= IC->fIC_raw[seg] ;
    }

    double IC1corr = (IC->fIC_raw[1]*(1-0.000686068*FF_IC_Y))*(1-4.88238e-05*FF_IC_Y+7.40395e-06*FF_IC_Y*FF_IC_Y);
    double DE_Bis = 0.5*(IC1corr+IC->fIC_raw[2]+IC->fIC_raw[3])+IC->fIC_raw[4];

    Etot = E+DE_Bis;

    //===========================================================================================================
    //                                  Fill histo
    //===========================================================================================================
    if (cut == true && !(CutZ->IsInside(Etot,DE_Bis)) ){ ; } // end cut
    else {
      for (int seg=0 ; seg<11 ; seg++ ){

        hICX[seg]->Fill(FF_IC_X,IC->fIC_raw[seg]);
        hICY[seg]->Fill(FF_IC_Y,IC->fIC_raw[seg]);

      }//end loop seg
    }
  } //end loop entries

  //ReProfile

  for (int seg=0; seg<11 ;seg++){
    hICX_Profile[seg] = (TH1F*)hICX[seg]->ProfileX();
    hICY_Profile[seg] = (TH1F*)hICY[seg]->ProfileX();
  }

  TFile* outfile = new TFile("Output/HistoDampen.root","recreate");
  for (int seg=0 ; seg<11 ;seg++){
    hICX[seg]->Write();
    hICY[seg]->Write();
    hICX_Profile[seg]->Write();
    hICY_Profile[seg]->Write(); 
  }
  outfile->Close();
}
